import turbogears, cherrypy
from turbogears import controllers, expose, validate, redirect

from turbosetup.decorator import require_login

class SetupController(controllers.RootController):
    def __init__(self, *args, **kw):
	super(SetupController,self).__init__( *args, **kw)
	self.templates = dict(index="turbosetup.templates.index",
			      login="turbosetup.templates.login")
	self.loginmessage = _("Please log in")

    def index(self):
        return dict(tg_template=self.templates['index'])
    index = expose()(index)
    index = require_login()(index)

    def login(self):
        forward_url=cherrypy.request.headers.get('Referer','/')
        previous_url=None 
	loginmessage = self.loginmessage
	self.loginmessage = _("Please log in")

	return dict(message=self.loginmessage,
		    previous_url=previous_url,
		    original_parameters=cherrypy.request.params,
		    forward_url=forward_url,
		    tg_template=self.templates['login'])
    login = expose()(login)

    def process_login(self, user_name=None, password=None, forward_url=None):
	if not user_name == turbogears.config.get('setup.uname',False) \
	   or not password == turbogears.config.get('setup.passw',False):
	    self.loginmessage = _("Invalid username or password")
	    raise redirect(turbogears.url('/login'))

	turbogears.config.update({'setup.logged_in' : True})
	# TODO figure out a better redirection system
	raise redirect(turbogears.url('/'))
    process_login = expose()(process_login)

    def logout(self):
	turbogears.config.update({'setup.logged_in' : False})
	raise redirect(turbogears.url('/'))
    logout = expose()(logout)
